#include <math.h>

int hough(int iimage[512][512], float fimage[512][512],
          int minline, int maxline)
{
    int x;
    int y;
    int thetaix;
    int pixel;
    float fpixel, theta, r;
    int rix;
    float thetamin, thetamax, thetastep;
    float rmin, rmax, rstep;
    const float pi = 3.14;

    for (x=0; x<512; x++)
    {
        for (y=0; y<512; y++)
        {
            fimage[x][y] = 0;
        };
    };

    rmin = -256*sqrt(2);
    rmax = 256*sqrt(2);
    rstep = 511/(rmax-rmin);
    thetamin = 0;
    thetamax = 2*pi;
    thetastep = 511/(thetamax-thetamin);
    for (y=minline; y<(maxline+1); y++)
    {
        for (x=0; x<(512); x++)
        {
            /* if (iimage[x][y]!=0) */
            {
                for (thetaix=1; thetaix<512; thetaix++)
                {
                   theta = thetaix/thetastep;
                   r = x*cos(theta) + y * sin(theta);
                   r = r*rstep;
                   rix = ((int)r) + 512;
                   if ((rix>-1) & (rix<513) & (thetaix>-1) & (thetaix<513))
                      fimage[thetaix][rix] = fimage[thetaix][rix]+iimage[x][y];
                };
            };
        };
        printf ("pid: %d; y = %d\n",getpid(),y);  fflush(stdout);
    };
};

int acc2img(float iimage[512][512], int oimage[512][512])
{
    int x,y;
    int pixel;
    float fpixel;
    float maxval;
    maxval = 0;
    for (x=1; x<511; x++)
    {
        for (y=1; y<511; y++)
        {
            if (maxval<iimage[x][y])
               maxval = iimage[x][y];
        };
    };
    for (x=1; x<511; x++)
    {
        for (y=1; y<511; y++)
        {
            fpixel = sqrt(iimage[x][y])/sqrt(maxval);
            /* fpixel = iimage[x][y]/maxval; */
            fpixel = 255*fpixel;
            pixel = (int)fpixel;
            oimage[x][y] = pixel;
        };
    };
};
