/* houghseq.c in houghpar.c */
/* Izracuna Houghov transform na zaporedni oziroma vzporedni nacin */
/* Janez Pers, 2001 */

#include <stdio.h>
#include <time.h>
#include <sys/types.h>
#include <string.h>
#include "pgmio.c"
#include "hough.c"

#define MAXZNAKOV 255

main(int argc, char *argv[])
{
/* Spremenljivke za merjenje casa, ki ga program porabi za obdelavo */
time_t starttime;
time_t endtime;
double processingtime;

/* Imena datotek in kazalci na datoteke */
char infilename [MAXZNAKOV];
char outfilename [MAXZNAKOV];
FILE *infile;
FILE *outfile;

/* Vhodna in izhodna slika ter zacasni akumulator*/
int inimage[512][512];
int outimage[512][512];
float accumulator[512][512];

/* Splosnonamenski stevec */
int i;

/* Preverimo stevilo vhodnih parametrov, ce argc!=3 izpisemo navodila */
if (argc!=3)
{
   printf("\nHOUGHX.C - Izracun Houghove transformacije. \n");
   printf("\nUporaba: HOUGHPSEQ ali HOUGHPAR <vhodna PGM slika> <izhodna PGM slika> \n");
   printf("Vhodna slika mora biti obvezno dimenzij 512x512. \n\n");
   exit (1);
};

/* Prenesemo vrednosti argumentov v ustrezni spremenljivki */
strcpy(infilename,  argv[1]);
strcpy(outfilename, argv[2]);

printf("\nHOUGHX.C - Izracun Houghove transformacije. \n");

/* Preberemo vhodno sliko */
pgmread(infilename, inimage);

/* Zapomni si cas zacetka racunanja */
starttime = time(NULL);
printf ("Zacetek racunanja ob: %s", ctime(&starttime));

/* Obdelaj sliko */
hough(inimage, accumulator, 0, 511);

/* Zapomni si cas konca racunanja */
endtime = time(NULL);
printf ("Konec racunanja ob: %s \n", ctime(&endtime));

/* Izracunaj porabljen cas v sekundah */
processingtime = difftime(endtime, starttime);
printf ("Cas racunanja: %.0f sekund. \n", processingtime);

/* Skaliraj akumulator, ter ga prepisi v izhodno sliko */

acc2img(accumulator, outimage);

/* Zapisemo izhodno sliko */
pgmwrite(outfilename, outimage);

}
