int pgmread(char filename[], int image[512][512])
{
    FILE *infile;
    char fileline [80]; /* Po definiciji zapisa PGM je vrstica lahko dolga najvec 70 znakov */
    
    /* Indeksa v sliko */
    int x;
    int y;
    int pixel;
    
    /* Stevec elementov */
    long count;
    
    printf("Berem vhodno datoteko: %s \n", filename);
    
    /* Odpremo vhodno datoteko */
    infile = fopen(filename, "rt");
    if (infile==NULL)
    {
        printf("Napaka pri odpiranju vhodne datoteke! \n");
        exit(2);
    };
    
    /* Preberemo glavo PGM datoteke */
    fgets(fileline, 79, infile);
    if (memcmp(fileline, "P2", 2)!=0)
    {
    	printf("Napaka, datoteka ni tipa PGM, glava je: %s",fileline);   
    	exit(3);
    };
    
    /* Preberemo se ostale specifikacije slike, ki nas ne zanimajo */
    fgets(fileline, 79, infile);    /* Kreator */
    fgets(fileline, 79, infile);    /* Dimenzije */
    fgets(fileline, 79, infile);    /* Maksimalni element */
 
    /* Beremo elemente po vrsti kot ASCII vrednosti */
    count = 0;
    for (y=0; y<512; y++)
    {    
    	for(x=0; x<512; x++)
    	{       	    
       	    fscanf(infile, "%u", &pixel);
       	    image[x][y] = pixel;
       	    /* printf("%d ",image[x][y]); */
       	    count++;       	           	    
       	    if (feof(infile)!=0)
    	    {
    	    	printf("Prebranih %u elementov. %d %d \n", count,x,y);   
    	        printf("Napaka, vhodna datoteka ima premalo elementov! \n");
    	        exit(4);
    	    };    	    
    	};
    	
    };
    printf ("Prebranih %u elementov. \n", count);   
    fscanf(infile, "%u", &pixel); 
    if (feof(infile)==0)
    {
    	printf("Opozorilo: vhodna datoteka ima prevec elementov! \n");
    };
    /* Zapremo vhodno datoteko */
    fclose(infile);    
};

int pgmwrite(char filename[], int image[512][512])
{
    FILE *outfile;

    /* Indeksa v sliko */
    int x;
    int y;
    int pixel;

    /* Stevec elementov */
    long count;

    printf("Zapisujem izhodno datoteko: %s \n", filename);

    /* Odpremo izhodno datoteko */
    outfile = fopen(filename, "wt");
    if (outfile==NULL)
    {
        printf("Napaka pri odpiranju izhodne datoteke! \n");
        exit(2);
    };

    /* Zapisemo glavo PGM datoteke */
    fputs("P2\n", outfile);

    /* Zapisemo se ostale specifikacije slike */
    fputs("#HOUGHSEQ.C/HOUGHPAR.C\n", outfile);    /* Kreator */
    fputs("512 512\n", outfile);                   /* Dimenzije */
    fputs("255\n", outfile);                       /* Maksimalni element */

    /* Zapisujemo elemente po vrsti kot ASCII vrednosti */
    count = 0;
    for (y=0; y<512; y++)
    {
    	for(x=0; x<512; x++)
    	{       	
       	    pixel = image[x][y];
       	    fprintf(outfile, "%d ", pixel);       	
       	    count++;       	           	
       	    /* Prelomimo vrstico na vsakih 12 zapisanih elementov */
       	    if ((count % 12)==0) fprintf(outfile, "\n");
    	};    	
    };
    printf ("Zapisanih %u elementov. \n", count);

    /* Zapremo izhodno datoteko */
    fclose(outfile);
};
